# /u/sy/beebe/2-13/makeindex/test/texbk.awk, Mon Apr  4 14:30:43 1994
# Edit by Nelson H. F. Beebe <beebe@sunrise>
# ========================================================================
# Extract the TeXbook index and reformat into MakeIndex style for use as
# a test program
#
# Usage:
#	Edit out the index from texman.doc into texbk.raw, then
#	nawk -f texbk.awk texbk.raw >texbk.idx
#
# [04-Apr-1994]
# ========================================================================
BEGIN {FS = ","}
index($0,",") > 0 {
    topic = $1
    gsub(/\\/,"\\char92 ",topic) # \ -> \char92 
    gsub(/"/,"\\char34 ",topic)	 # " -> \char34 
    gsub(/[|]/,"\"|",topic)	 # | -> "\
    gsub(/@/,"\"@",topic)	 # @ -> "@
    gsub(/[^`'"|_\\\-A-Za-z0-9<>^\/\^[\]()@ ]/,"?",topic) # eliminate many special chars
    print_entry(2);
    while ($NF !~ /[.]$/)
    {
	getline;
	print_entry(1);
    }
}

function print_entry(n, k,limit,m)
{
    for (k = n; k <= NF; ++k) 
    {
	page_number = $k
	gsub(/[^0-9---]/,"",page_number)
	if (page_number != "")
	{
	    limit = split(page_number,v,"--")
	    for (m = 1; m <= limit; ++m)
	        if (v[m] ~ /^[0-9]+$/)
	            print "\\indexentry{" topic "}{" v[m] "}"
	}
    }
}

